import java.util.Collections;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;

public class Productivity {

	private ContextFreeGrammar grammar;
	private Set<NonTerminal> productive;

	public Productivity(ContextFreeGrammar grammar) {
		this.grammar = grammar;
		build();
	}

	/**
	 * Fill the set "productive" with the set of all productive symbols. TODO
	 */
	private void build() {
	}

	private Set<NonTerminal> get() {
		return Collections.unmodifiableSet(productive);
	}

	public static Set<NonTerminal> getProductiveNonTerminals(ContextFreeGrammar g) {
		return (new Productivity(g)).get();
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		ContextFreeGrammar g = ContextFreeGrammar.parse(sc);
		for (NonTerminal x : new TreeSet<>(getProductiveNonTerminals(g)))
			System.out.println(x);
		sc.close();
	}

}
