import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;

public class DerivationTreeFinder {

	private final ContextFreeGrammar grammar;
	private final Map<String, Set<DerivationTree>> derivationTrees = new HashMap<>();

	public DerivationTreeFinder(ContextFreeGrammar grammar) {
		this.grammar = grammar;
		derivationTrees.put("", Collections.emptySet());
	}

	/**
	 * Computes the set of all derivation trees of the given word with respect to any non-terminal 
	 * of the grammar.
	 * TODO
	 */
	public Set<DerivationTree> derivationTrees(String w) {
	    return null;
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		ContextFreeGrammar g = ContextFreeGrammar.parse(sc);
		String w = sc.nextLine();
		sc.close();
		if (!g.isCNF()) {
			System.err.println("Grammar is not in CNF!");
			return;
		}
		DerivationTreeFinder finder = new DerivationTreeFinder(g);
		Set<DerivationTree> ts = new TreeSet<>(finder.derivationTrees(w));
		for (DerivationTree t : ts)
			System.out.println(t);
	}

}
